<?php

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

/**
 * @file acs_onload.php
 * appellé depuis acs_options.php dans TOUS les cas
 * acs_options est le premier fichier du plugin chargé, avant même autoriser.php de la dist
 */

// Dossier des paramètres et images utilisateur
// User images and parameters
// compatible mutualisation (_DIR_SITE defini)
if (defined('_DIR_SITE')) {
	$dir_site = _DIR_SITE;
	$dir_site_absolu = _DIR_RACINE ? substr(_DIR_SITE, 3) : _DIR_SITE;
}
else {
	$dir_site = _DIR_RACINE;
	$dir_site_absolu = '';
}

// Racine des dossiers du site :
define('_ACS_DIR_SITE_ROOT', $dir_site);

// Dossier du cache ACS (par defaut: tmp/cache/acs)
define('_ACS_TMP_DIR', _ACS_DIR_SITE_ROOT . _NOM_TEMPORAIRES_INACCESSIBLES . 'cache/acs/');

// Set ACS par defaut - Default ACS set
if (!acs_get('ACS_SET')) {
	acs_set('ACS_SET', 'cat');
}

// Dossier des images du set ACS actif - Active ACS set images directory
$GLOBALS['ACS_CHEMIN'] = $dir_site_absolu . _NOM_PERMANENTS_ACCESSIBLES . '_acs/' . acs_get('ACS_SET');

// Chemin valable espace public aussi, pas comme _DIR_PLUGIN_ACS, qui est à proscrire
$cp = _DIR_PLUGINS . acs_get_from_active_plugin('ACS', 'dir');
define('_DIR_ACS', $cp . '/');
unset($cp);

// Définition du dossier global des squelettes actifs d'ACS (avec override)
// Global active ACS skeletons directory definition (with override)
$dossiers_squelettes_avant_override = explode(':', $GLOBALS['dossier_squelettes']);
if (acs_get('ACS_OVER')) {
	$tas = explode(':', acs_get('ACS_OVER'));
	foreach ($tas as $dir) {
		@include(_ACS_DIR_SITE_ROOT . $dir . '/mes_options.php');
		@include(_ACS_DIR_SITE_ROOT . $dir . '/mes_fonctions.php');
		if (in_array($dir_site_absolu . $dir, $dossiers_squelettes_avant_override)) {
			continue;
		}
		if (isset($GLOBALS['dossier_squelettes']) && $GLOBALS['dossier_squelettes']) {
			$GLOBALS['dossier_squelettes'] .= ':';
		}
		$GLOBALS['dossier_squelettes'] .= $dir_site_absolu . $dir;
	}
}
if (isset($GLOBALS['dossier_squelettes']) && $GLOBALS['dossier_squelettes']) {
	$GLOBALS['dossier_squelettes'] .= ':';
}
// On ajoute le chemin du modèle cat actif
$GLOBALS['dossier_squelettes'] .= 'plugins/' . acs_get_from_active_plugin('ACS', 'dir') . '/' . 'sets/' . acs_get('ACS_SET');

// dispatch public / privé
if ((_DIR_RESTREINT != '') && ($_POST['action'] != 'poster_forum_prive')) {
	// Sauts de ligne
	$GLOBALS['spip_pipeline']['pre_propre'] .= '|post_autobr';
}

include_spip('balise/acs_balises');

// Retourne une variable d'un plugin actif
function acs_get_from_active_plugin($plugin, $variable = false) {
	$meta_plugin = unserialize($GLOBALS['meta']['plugin']);
	$plugin = $meta_plugin[$plugin];

	if (!$variable) {
		return isset($plugin['dir']);
	}
	if (isset($plugin[$variable])) {
		return $plugin[$variable];
	}
	return false;
}
/**
 * Makes directory, returns TRUE if exists or made
 *
 * @param string $pathname The directory path.
 * @return boolean returns TRUE if exists or made or FALSE on failure.
 */
function mkdir_recursive($pathname) {
		@is_dir(dirname($pathname)) || mkdir_recursive(dirname($pathname));
		if (@is_dir($pathname)) {
			return true;
		}
		acs_log('mkdir_recursive(' . $pathname . ')', _LOG_DEBUG);
		return @mkdir($pathname);
}
/**
 * Lit, écrit, ou efface une variable
 */
function acs_get($var) {
	if (isset($GLOBALS['meta'][$var])) {
		return $GLOBALS['meta'][$var];
	}	else {
		return false;
	}
}
function acs_set($var, $value) {
	if ($value && strlen($value) > 0) {
		ecrire_meta($var, $value);
	}
	else {
		effacer_meta($var);
	}
}
function acs_unset($var) {
	acs_set($var, null);
}
/**
 * Force un recalcul des pages, CSS et scripts mis en cache
 */
function acs_recalcul() {
	acs_set('acsDerniereModif', time());
	touch_meta(false); // Force la reecriture du cache SPIP des metas
}
/**
 * Lit une variable meta à la façon de l'API cfg, suivant un chemin,
 * avec en plus la récursivité ACS (une variable ACS peut référencer une autre variable ACS)
 * Utilisé par la fonction balise_VAR()
 * @param src : tableau source
 * @param meta : nom de la variable meta à lire
 * @return : valeur de la variable (récursive)
 */
function meta_recursive($src, $meta) {
	$chemin = strtok($meta, '/');
	$val = $src[$chemin];
	// Si la valeur commence par "=", c'est une référence récursive à une autre variable ACS
	if (substr($val, 0, 1) == '=') {
		$val = meta_recursive($src, substr($val, 1) . substr($meta, strlen($chemin)));
	}
	// On appelle récursivement la fonction tant que $val est un array ou un array serialisé
	if (is_array($val)) {
		$val = meta_recursive($val, substr($meta, strlen($chemin) + 1));
	}
	elseif (is_array(unserialize($val))) {
		$val = meta_recursive(unserialize($val), substr($meta, strlen($chemin) + 1));
	}
	return $val;
}
/**
 * Journalise les actions du plugin ACS si _ACS_LOG est supérieur à 0 dans acs_options.php
 * @param txt: texte à journaliser
 * @param gravite: cf. acs_options.php
 */
function acs_log($txt, $gravite = _LOG_HS) {
	if (_ACS_LOG > _LOG_HS) {
		spip_log($txt, 'acs', _LOG_FILTRE_GRAVITE);
	}
}
/**
 * Retourne un objet ou un tableau sous forme de tableau affichable en html
 * @param r : objet ou tableau
 * @param html : retourne du html si vrai
 * @return : objet ou tableau en mode texte ou html lisible
 */
function dbg($r, $html = false) {
	if (is_object($r) or is_array($r)) {
			ob_start();
			print_r($r);
			$r = ob_get_contents();
			ob_end_clean();
			if ($html) {
				$r = htmlentities($r);
			}
			$srch = ['/Array[\n\r]/', '/\s*[\(\)]+/', '/[\n\r]+/', '/ (?= )/s'];
			$repl = ['', '', "\n" , ($html ? '&nbsp;' : ' ')];
			$r = preg_replace($srch, $repl, $r);
			if ($html) {
				$r = nl2br($r);
			}
	}
	return $r;
}
