<?php

/*/
 * Appels aux fonctions de mise en page ACS
 * Simplifie le suivi des versions de spip, et assure la compatibilité depuis 1.9.2
 * au niveau de l'affichage de l'espace ecrire
 */
if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/presentation');

function acs_commencer_page($titre = '', $rubrique = 'configuration', $sous_rubrique = 'acs') {
	$commencer_page = charger_fonction('commencer_page', 'inc');
	$r = $commencer_page($titre, $rubrique, $sous_rubrique);
	return $r;
}

/*
 * Retourne une boite info ACS standardisée
 */
function acs_info_box($titre, $description, $info, $icon) {
	if ($description) {
		$r .= '<div>' . $description . '</div>';
	}
	if ($info) {
		$r .= '<br /><div class="onlinehelp">' . $info . '</div>';
	}
	return acs_box($titre, '<img src="' . _DIR_PLUGIN_ACS . 'images/info.png" alt="&#9432;" />', $r, '', '', $icon);
}
// retourne une boîte alerte de SPIP
function acs_alert_box($msg) {
	return debut_boite_alerte() . $msg . fin_boite_alerte();
}

/**
 * Boite
 * @param string titre : titre
 * @param string titre2: autre élément positionné à droite dans la barre de titre
 * @param string contenu: contenu
 * @param string class: classe css
 * @param string style: style css
 * @param string icon: chemin de l'icône
	*/
function acs_box($titre, $titre2 = false, $contenu = '', $class = '', $style = '', $icon = false) {
	if ($class) {
		$class = " $class";
	}
	$r = '<div class="acs_box' . $class . '"' . ($style != '' ? ' style = "' . $style . '"' : '') . '>';
	if ($icon) {
		$r .= '<div style="position: absolute; top: -16px; left: 10px; z-index: 100;"><img src="' . $icon . '" alt="" /></div>';
	}
	if ($titre) {
		$r .= '<div class="acs_box_titre">' . $titre . '';
		if ($titre2) {
			$r .= '<span class="acs_box_titre2">' . $titre2 . '</span>';
		}
		$r .= '</div>';
	}
	$r .= '<div class="acs_box_texte arial2">' . $contenu . '</div>';
	$r .= '</div>';
	//spip_log($r);
	return $r;
}

// Affichage 3 colonnes dans l'interface admin spip
function acs_3colonnes($col1, $col2, $col3) {
	echo '<div class="acs_colonnes">' .
	 '<div class="acs_col1"><div class="acs_col">' . $col1 . '</div></div>' .
	 '<div class="acs_col2" style="width:50%"><div class="acs_col">' . $col2 . '</div></div>' .
	 '<div class="acs_col3"><div class="acs_col">' . $col3 . '</div></div>' .
	 '</div><br style="clear: both"/>';
}

/**
 * Crée un lien image plieur/déplieur jQuery pour les éléments de la classe $classe
 * Utilise l'url si pas de jQuery ou pas de javascript (soft downgrade)
 *
 * Classes définies:
 * plieur : lien(s) a href
 */
function acs_plieur($id_plieur, $classe_a_plier, $url, $on = false, $onclick = false, $texte = '') {
	if ($onclick) {
		$onclick = ' onclick="' . $onclick . '"';
	}
	return '<a href="' . $url . '" id="' . $id_plieur . '" class="acs_plieur' . ($on ? ' plon' : '') . '" name="plieur_' . $classe_a_plier . '" title="' .  _T('info_deplier') . '"' . $onclick . '>' . ($texte ? ' ' . $texte . ' ' : '') . '</a>';
}
